package model;

import java.util.ArrayList;
import java.util.*;

public class School
{
	private ArrayList<Student> students;
	
	public School()
	{
		students = new ArrayList<Student>();
	}
	
	public void add(Student s)
	{
		students.add(s);
	}
	
	public int maxAlterAnstieg()
	{
		return 0;
	}

	/* FALSCH DA COLLECTION SICH ÄNDERT!!!
	public void loscheManner()
	{
		for (Student s: students)
		{
			if (s.isMannlich())
			{
				students.remove(s);
			}
		}
	}*/

	public void loscheManner()
	{
		Student s;
		Iterator<Student> iterator;
		
		iterator = students.iterator();
		while (iterator.hasNext())
		{
			s = iterator.next();
			if (s.isMannlich())
			{
				iterator.remove();
			}
		}
	}
	
	public int frauenQuote()
	{
		int anzFrauen;
		
		anzFrauen = 0;
		for (Student s: students)
		{
			if (! s.isMannlich())
			{
				anzFrauen++;
			}
		}
		if (students.size() > 0)
		{
			//public static long round(double a)
			return (int)Math.round((double)anzFrauen*100/students.size());
			//return anzFrauen*100/students.size();
		}
		else
		{
			System.out.println("Fehler: keine StudentInnen in der Schule!");
			return -1;
		}
	}

	
	public int frauenQuote2()
	{
		int anzFrauen;
		Student s;
		Iterator<Student> iterator;
		
		anzFrauen = 0;
		iterator = students.iterator();
		while (iterator.hasNext())
		{
			s = iterator.next();
			if (! s.isMannlich())
			{
				anzFrauen++;
			}
		}
		if (students.size() > 0)
		{
			//public static long round(double a)
			return (int)Math.round((double)anzFrauen*100/students.size());
			//return anzFrauen*100/students.size();
		}
		else
		{
			System.out.println("Fehler: keine StudentInnen in der Schule!");
			return -1;
		}
	}

	
	public Student maxAlter()
	{
		int max;
		Student maxStudent;
		Student student;
		Iterator<Student> it;
		
		max = -999;
		maxStudent = null;
		it = students.iterator();
		while (it.hasNext())
		{
			student = it.next();
			if (student.getAlter() > max)
			{
				max = student.getAlter();
				maxStudent = student;
			}
		}
		return maxStudent;
	}

	public Student maxAlter2()
	{
		int max;
		Student maxStudent;
		
		max = -999;
		maxStudent = null;
		for (Student student: students)
		{
			if (student.getAlter() > max)
			{
				max = student.getAlter();
				maxStudent = student;
			}
		}
		return maxStudent;
	}

	public String toString()
	{
		String erg = "";
		
		for (Student student: students)
		{
			erg = erg + student.toString() + "\n";
		}		
		return erg;
	}
	
}
